package me.axieum.mcmod.authme.api.gui;

import net.minecraft.class_2588;
import net.minecraft.class_437;

/**
 * A screen for handling user authentication.
 */
public abstract class AuthScreen extends class_437
{
    // The parent (or last) screen that opened this screen
    protected final class_437 parentScreen;
    // The screen to be returned to after a successful login
    protected final class_437 successScreen;
    // True if repeat keyboard events should be enabled for this screen
    protected boolean enableKeyboardRepeatEvents = false;
    // True if the login task completed successfully
    protected boolean success = false;
    // True if the screen should be closed on success stat (via render thread)
    protected boolean closeOnSuccess = false;

    /**
     * Constructs a new authentication screen.
     *
     * @param title         screen title
     * @param parentScreen  parent (or last) screen that opened this screen
     * @param successScreen screen to be returned to after a successful login
     */
    public AuthScreen(class_2588 title, class_437 parentScreen, class_437 successScreen)
    {
        super(title);
        this.parentScreen = parentScreen;
        this.successScreen = successScreen;
    }

    @Override
    protected void method_25426()
    {
        super.method_25426();
        assert field_22787 != null;

        // Optionally enable keyboard repeat events, e.g. allow holding down backspace
        field_22787.field_1774.method_1462(enableKeyboardRepeatEvents);
    }

    @Override
    public void method_25393()
    {
        super.method_25393();

        // Optionally close the screen if the login task completed successfully
        if (success && closeOnSuccess) this.method_25419();
    }

    @Override
    public void method_25419()
    {
        if (field_22787 != null) field_22787.method_1507(success ? successScreen : parentScreen);
    }

    @Override
    public void method_25432()
    {
        if (enableKeyboardRepeatEvents && field_22787 != null) field_22787.field_1774.method_1462(false);
    }
}
