package me.axieum.mcmod.authme.impl.gui;

import me.axieum.mcmod.authme.api.util.SessionUtils;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_2585;
import net.minecraft.class_2588;
import net.minecraft.class_344;
import net.minecraft.class_4185;
import net.minecraft.class_437;
import net.minecraft.class_4587;

import static me.axieum.mcmod.authme.impl.AuthMe.WIDGETS_TEXTURE;

/**
 * A screen for choosing a user authentication method.
 */
public class AuthMethodScreen extends class_437
{
    // The parent (or last) screen that opened this screen
    private final class_437 parentScreen;
    // A greeting message shown for the current session
    private class_2561 greeting = null;

    /**
     * Constructs a new authentication method choice screen.
     *
     * @param parentScreen parent (or last) screen that opened this screen
     */
    public AuthMethodScreen(class_437 parentScreen)
    {
        super(new class_2588("gui.authme.method.title"));
        this.parentScreen = parentScreen;
    }

    @Override
    protected void method_25426()
    {
        super.method_25426();
        assert field_22787 != null;

        // Set the greeting message
        greeting = new class_2588(
            "gui.authme.method.greeting",
            new class_2585(SessionUtils.getSession().method_1676()).method_27692(class_124.field_1054)
        );

        // Add a button for the 'Microsoft' authentication method
        method_25411(
            new class_344(
                field_22789 / 2 - 20 - 10 - 4, field_22790 / 2 - 5, 20, 20,
                0, 0, 20, WIDGETS_TEXTURE, 128, 128,
                button -> field_22787.method_1507(new MicrosoftAuthScreen(this, parentScreen)),
                (btn, mtx, x, y) -> method_25424(
                    mtx, new class_2588("gui.authme.method.button.microsoft"), x, y
                ),
                new class_2588("gui.authme.method.button.microsoft")
            )
        );

        // Add a button for the 'Mojang (or legacy)' authentication method
        method_25411(
            new class_344(
                field_22789 / 2 - 10, field_22790 / 2 - 5, 20, 20,
                20, 0, 20, WIDGETS_TEXTURE, 128, 128,
                button -> field_22787.method_1507(new MojangAuthScreen(this, parentScreen)),
                (btn, mtx, x, y) -> method_25424(
                    mtx, new class_2588("gui.authme.method.button.mojang"), x, y
                ),
                new class_2588("gui.authme.method.button.mojang")
            )
        );

        // Add a button for the 'Offline' authentication method
        method_25411(
            new class_344(
                field_22789 / 2 + 10 + 4, field_22790 / 2 - 5, 20, 20,
                40, 0, 20, WIDGETS_TEXTURE, 128, 128,
                button -> field_22787.method_1507(new OfflineAuthScreen(this, parentScreen)),
                (btn, mtx, x, y) -> method_25424(
                    mtx, new class_2588("gui.authme.method.button.offline"), x, y
                ),
                new class_2588("gui.authme.method.button.offline")
            )
        );

        // Add a button to go back
        method_25411(
            new class_4185(
                field_22789 / 2 - 50, field_22790 / 2 + 27, 100, 20,
                new class_2588("gui.back"),
                button -> method_25419()
            )
        );
    }

    @Override
    public void method_25394(class_4587 matrices, int mouseX, int mouseY, float delta)
    {
        assert field_22787 != null;

        // Render the background before any widgets
        method_25420(matrices);

        // Render a title for the screen
        method_27534(matrices, field_22787.field_1772, field_22785, field_22789 / 2, field_22790 / 2 - 27, 0xffffff);

        // Render a greeting for the current session
        if (greeting != null) {
            method_27534(matrices, field_22787.field_1772, greeting, field_22789 / 2, field_22790 / 2 - 47, 0xa0a0a0);
        }

        // Cascade the rendering
        super.method_25394(matrices, mouseX, mouseY, delta);
    }

    @Override
    public void method_25419()
    {
        if (field_22787 != null) field_22787.method_1507(parentScreen);
    }
}
