package me.axieum.mcmod.authme.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import me.axieum.mcmod.authme.api.gui.widget.AuthButtonWidget;
import me.axieum.mcmod.authme.api.util.SessionUtils;
import me.axieum.mcmod.authme.impl.gui.AuthMethodScreen;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_2585;
import net.minecraft.class_2588;
import net.minecraft.class_437;
import net.minecraft.class_500;

import static me.axieum.mcmod.authme.impl.AuthMe.CONFIG;
import static me.axieum.mcmod.authme.impl.AuthMe.LOGGER;
import static me.axieum.mcmod.authme.impl.AuthMe.getConfig;

/**
 * Injects a button into the multiplayer screen to open the authentication screen.
 */
@Mixin(class_500.class)
public abstract class MultiplayerScreenMixin extends class_437
{
    private MultiplayerScreenMixin(class_2561 title)
    {
        super(title);
    }

    /**
     * Injects into the creation of the screen and adds the authentication button.
     *
     * @param ci injection callback info
     */
    @Inject(method = "init", at = @At("HEAD"))
    private void init(CallbackInfo ci)
    {
        LOGGER.info("Adding auth button to the multiplayer screen");
        assert field_22787 != null;

        // Create and add the button to the screen
        method_25411(
            new AuthButtonWidget(
                this,
                getConfig().authButton.x,
                getConfig().authButton.y,
                btn -> field_22787.method_1507(new AuthMethodScreen(this)),
                // Optionally, enable button dragging
                getConfig().authButton.draggable ? btn -> {
                    // Sync configuration with the updated button position
                    LOGGER.info("Moved the auth button to {}, {}", btn.field_22760, btn.field_22761);
                    getConfig().authButton.x = btn.field_22760;
                    getConfig().authButton.y = btn.field_22761;
                    CONFIG.save();
                } : null,
                // Add a tooltip to greet the player
                (btn, mtx, x, y) -> method_25424(mtx, new class_2588(
                    "gui.authme.button.auth.tooltip",
                    new class_2585(SessionUtils.getSession().method_1676()).method_27692(class_124.field_1054)
                ), x, y),
                // Non-visible text, useful for screen narrator
                new class_2588("gui.authme.button.auth")
            )
        );
    }
}
